<app-loader *ngIf="isLoad">  </app-loader>


<div *ngIf="error && !isLoad">
	<i>{{error}}</i>
</div>

<form #testsForm="ngForm">
	<div class="art-card" *ngIf="tests">
	<table mat-table  [dataSource]="tests || []">
		<ng-container matColumnDef="testType">
			<th mat-header-cell *matHeaderCellDef > Тип вступительного испытания </th>
			<td mat-cell *matCellDef="let row"> {{ row.name_entrance_test_type }}</td>
		</ng-container>

		<ng-container matColumnDef="subject">
			<th mat-header-cell *matHeaderCellDef > Предмет </th>
			<td mat-cell *matCellDef="let row">
				<span *ngIf="row.is_ege">{{ row.name_subject }}</span>
				<span *ngIf="!row.is_ege">{{ row.test_name }}</span>
			</td>
		</ng-container>

		<ng-container matColumnDef="ege">
			<th mat-header-cell *matHeaderCellDef > Тип </th>
			<td mat-cell *matCellDef="let row"> {{ row?.is_ege | yesNo: 'ЕГЭ': 'Не ЕГЭ' || '-'}}</td>
		</ng-container>

		<ng-container matColumnDef="minScore">
			<th mat-header-cell *matHeaderCellDef > Мин. балл </th>
			<td mat-cell *matCellDef="let row"> {{ row.min_score }}</td>
		</ng-container>

		<ng-container matColumnDef="priority">
			<th mat-header-cell *matHeaderCellDef > Приоритет </th>
			<td mat-cell *matCellDef="let row"> {{ row.priority }}</td>
		</ng-container>

		<ng-container matColumnDef="dates">
			<th mat-header-cell *matHeaderCellDef > Даты проведения </th>
			<td mat-cell *matCellDef="let row">
				<ng-container *ngIf="!row.is_ege">
					<div  class="my-4" *ngFor="let date of row.entrance_test_calendar_dates">
						{{date | date: 'dd.MM.yyyy HH:mm, (zzzz)'}}
					</div>
				</ng-container>

			</td>
		</ng-container>

		<ng-container matColumnDef="chooseDate">
			<th mat-header-cell *matHeaderCellDef > Выбранная дата </th>
			<td mat-cell *matCellDef="let row">
				<span *ngIf="row.choose_entrance_test_date; else notChooseDate">
					{{ row.choose_entrance_test_date?.date | date: 'dd.MM.yyyy HH:mm, (zzzz)'}}
				</span>
				<ng-template #notChooseDate>
					{{"-" }}
				</ng-template>

			</td>
		</ng-container>

		<ng-container matColumnDef="mark">
			<th mat-header-cell *matHeaderCellDef > Балл по документу </th>
			<td mat-cell *matCellDef="let row">
				<ng-container *ngIf="row.app_entrance_test">
					{{ row?.app_entrance_test.result_value }}
				</ng-container>
			</td>
		</ng-container>

		<ng-container matColumnDef="docInfo">
			<th mat-header-cell *matHeaderCellDef > Подтверждающий документ </th>
			<td mat-cell *matCellDef="let row">
				<ng-container *ngIf="row.app_entrance_test">
					{{ row?.app_entrance_test.document_name_category }}
				</ng-container>
			</td>
		</ng-container>

		<ng-container matColumnDef="uid">
			<th mat-header-cell *matHeaderCellDef > UID </th>
			<td mat-cell *matCellDef="let row">
				<ng-container *ngIf="row.app_entrance_test">
					{{ row?.app_entrance_test.uid }}
				</ng-container>
			</td>
		</ng-container>


		<ng-container  matColumnDef="actions">
			<th mat-header-cell *matHeaderCellDef ></th>
			<td mat-cell *matCellDef="let row;  let index = index">

				<div [hidden]="indexAddingData">
					<ng-container *ngIf="row.app_entrance_test; else emptyTest">
						<button mat-icon-button (click)="edit(row.app_entrance_test, index)">
							<mat-icon svgIcon="pencil"></mat-icon>
						</button>

						<button mat-icon-button (click)="delete($event, row.app_entrance_test.id, index)">
							<mat-icon svgIcon="delete"></mat-icon>
						</button>
					</ng-container>
					<ng-template #emptyTest>
						<button mat-icon-button
							matTooltip="Добавить результат ВИ"
							(click)="addTest(row, index)">
							<mat-icon svgIcon="plus"></mat-icon>
						</button>
					</ng-template>

					<ng-container *ngIf="!row.is_ege">
						<ng-container *ngIf="!row.choose_entrance_test_date; else emptyChooseDate">
							<button mat-icon-button
								matTooltip="Выбрать дату ВИ"
								(click)="chooseTestDate(row, index)">
								<mat-icon svgIcon="calendar-plus">  </mat-icon>
							</button>
						</ng-container>
						<ng-template #emptyChooseDate>
							<button mat-icon-button
								matTooltip="Очистить выбранную дату"
								(click)="deleteTestDate(row.choose_entrance_test_date, index)">
							<mat-icon svgIcon="calendar-remove"></mat-icon>
							</button>
						</ng-template>
					</ng-container>


				</div>


			</td>
		</ng-container>

		<ng-container matColumnDef="selectTest">
			<td mat-cell *matCellDef="let row" [colSpan]="2">
				<div>
					<mat-form-field fxFlex="">
						<mat-label> Вступительное испытание </mat-label>
						<mat-select
							(valueChange)="changeSelectTest($event)"
							[(ngModel)]="addingData.entrance_test"
							name="id_entrance_test"
							required >
							<mat-select-trigger>
								{{addingData.entrance_test?.name_subject}}
							</mat-select-trigger>
							<mat-option class="multiline" *ngFor="let item of cls.tests.data" [value]="item">
								<ng-container>
									<div> {{item?.name_subject}} </div>
									<div class="mat-caption"> {{item?.name_entrance_test_type}} ({{item?.is_ege  | yesNo: 'ЕГЭ': 'Не ЕГЭ' }}) </div>

								</ng-container>

							</mat-option>


						</mat-select>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="setMark">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field fxFlex="" appearance="standard" class="xs-input">
						<input [(ngModel)]="addingData.result_value"
							[appMin]="row?.min_score"
							appInteger
							matInput
							name="mark"
							placeholder="Балл"
							required>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="selectDoc">
			<td mat-cell *matCellDef="let row">
				<button mat-stroked-button (click)="selectDoc()" *ngIf="!addingData.id_document; else docInfoContent"> Выбрать документ </button>
				<ng-template #docInfoContent>
					{{addingData.document_name_category}}
					<button mat-icon-button (click)="addingData.id_document = null"> <mat-icon svgIcon="delete"></mat-icon> </button>
				</ng-template>

				<input required="" [(ngModel)]="addingData.id_document" name="id_document" [hidden]="true">
			</td>
		</ng-container>



		<ng-container matColumnDef="setUid">
			<td mat-cell *matCellDef="let row">
				<div>
					<mat-form-field fxFlex="" class="xxl-input" appearance="standard">
						<input matInput
							[(ngModel)]="addingData.uid"
							name="uid"
							placeholder="uid"
							appNullValue>
					</mat-form-field>
				</div>

			</td>
		</ng-container>

		<ng-container matColumnDef="actionsSave">
			<td mat-cell *matCellDef="let row; let index = index">
				<ng-container *ngIf="addingData.id; else addingButton">
					<button mat-icon-button (click)="save(index)" [disabled]="testsForm.invalid">
						<mat-icon svgIcon="content-save-outline"></mat-icon>
					</button>
				</ng-container>
				<ng-template #addingButton>
					<button mat-icon-button (click)="add()" [disabled]="testsForm.invalid">
						<mat-icon svgIcon="content-save-outline"></mat-icon>
					</button>
				</ng-template>

				<button mat-icon-button (click)="cancel()">
					<mat-icon svgIcon="cancel" matTooltip="Отменить изменения"></mat-icon>
				</button>
			</td>
		</ng-container>

		<ng-container matColumnDef="noRecord">
			<td mat-footer-cell *matFooterCellDef [colSpan]="testsColumns.length" ><i>Вступительных испытаний не найдено</i></td>
		</ng-container>





		<tr mat-header-row *matHeaderRowDef="testsColumns"></tr>
		<tr mat-row  *matRowDef="let row; columns: testsColumns; when: !isAddTest"></tr>
		<tr mat-row  *matRowDef="let row; columns: addingColumns; when: isAddTest"></tr>
		<tr mat-footer-row *matFooterRowDef="['noRecord'] "
			[hidden]="tests.length !== 0"></tr>

	</table>
</div>
</form>
